#include "server.h"

int main(int argc, char* argv[])
{
	/* handle to socket */
	int hSocket = (int)NULL,
		hServerSocket = (int)NULL;

	int nAddressSize = sizeof(struct sockaddr_in);
	int nHostPort = (int)NULL;
	int err;

	/* holds info about a machine */
	struct hostent * pHostInfo = (struct hostent *)NULL;

	/* Internet socket address stuct */
	struct sockaddr_in Address;

	struct client * clients = (struct client *)NULL;
	pthread_t threads;
	//pthread_t clients;

	system(__CLEAR_SCREEN__);

	char * end = {"2"};
	if ( argc != 2 || (nHostPort = strtol(argv[1], (char **)NULL, 10)) == 0 )
	{
		printf("\nCould not make a socket\n");
		usage();
	}

	puts("\nStarting server");
	puts("Making socket");

	/* make a socket */
	hServerSocket = socket(AF_INET, SOCK_STREAM, 0);
	if ( hServerSocket == SOCKET_ERROR )
	{
		printf("\nCould not make a socket\n");
		return 0;
	}

	/* fill address struct */
	Address.sin_addr.s_addr = INADDR_ANY;
	Address.sin_port = htons(nHostPort);
	Address.sin_family = AF_INET;

	printf("\nBinding to port %d...\n", nHostPort);

	/* bind to a port */
	if ( bind(hServerSocket, (struct sockaddr*)&Address, sizeof(Address)) == SOCKET_ERROR )
	{
		printf("\nCould not connect to host\n");
		return 0;
	}

	/* get port number */
	getsockname( hServerSocket, (struct sockaddr *) &Address,(socklen_t *)&nAddressSize);
	printf("\nopened socket as fd (%d) on port (%d) for stream i/o\n", hServerSocket, ntohs(Address.sin_port));

	printf("Server\n\
			sin_family        = %d\n\
			sin_addr.s_addr   = %d\n\
			sin_port          = %d\n"
			, Address.sin_family
			, Address.sin_addr.s_addr
			, ntohs(Address.sin_port)
			);
	printf("\nMaking a listen queue of %d elements", QUEUE_SIZE);

	/* establish listen queue */
	if ( listen(hServerSocket, QUEUE_SIZE) == SOCKET_ERROR )
	{
		printf("\nCould not listen\n");
		return 0;
	}

	for ( ; ; )
	{
		puts("\nWaiting for a connection\n");

		/* get the connected socket */
		hSocket = accept(hServerSocket, (struct sockaddr*)&Address, (socklen_t *)&nAddressSize);

		printf("%d\n\n", hSocket);

		clients = (struct client *) malloc(sizeof(struct client));
		clients->hSocket = hSocket;
		clients->last = time(NULL);

		pthread_create(&threads, NULL, handler, (void *)clients);
		clients = (struct client *)NULL;
		puts("jah era #5");
	}
	pthread_exit(NULL);
}

void * handler(void * pClient)
{
    char pBuffer[BUFFER_SIZE];
    struct client * client = (struct client *)pClient;
    int i = 0, err;
	time_t last;

    if ( close(client->hSocket) == SOCKET_ERROR )
    {
        printf("\nCould not close socket\n");
        return 0;
    }

	printf("%d", client->hSocket);
	//sin_addr.s_addr

    fflush(stdin);
    fflush(stdout);
    pthread_exit(NULL);
    /*
	printf("\nGot a connection");

	last = time(NULL);
	while ( time(NULL) - client->last < 10 )
	{
		printf("%s\n\n", "teste");
		sleep(1);
	}

	client->last = time(NULL);
	*/

    /**
	 * number returned by read() and write() is the number of bytes
     * read or written, with -1 being that an error occured
     * write what we received back to the server
	 **/

    /*
	strcpy(pBuffer, MESSAGE);
    printf("\nSending \"%s\" to client\n",pBuffer);
    write(client->hSocket, pBuffer, strlen(pBuffer)+1);
	*/

	/* read from socket into buffer */
	/*read(client->hSocket, pBuffer, sizeof(pBuffer));

	printf("Received from client: %s\n", pBuffer);

    if ( strcmp(pBuffer, MESSAGE) == 0 )
        printf("The messages match\n");
    else
        printf("Something was changed in the message\n");
	*/

    /*while (i < 10)
    {
		 printf("%d\n", i);
		 usleep(1000000);
		 i++;
    }*/

    /* close socket */
    /*printf("\nClosing the socket");
    if ( close(client->hSocket) == SOCKET_ERROR )
    {
        printf("\nCould not close socket\n");
        return 0;
    }

    fflush(stdin);
    fflush(stdout);
	free(client);
    pthread_exit(NULL);
	*/
}
