#define HAVE_PTHREAD_H		1		/* <pthread.h> */
#define HAVE_STRINGS_H		1		/* <strings.h> */

//#define HAVE_SYS_FILIO_H	1		/* <sys/filio.h> */
#define HAVE_SYS_IOCTL_H	1		/* <sys/ioctl.h> */
#define HAVE_SYS_SELECT_H	1		/* <sys/select.h> */
//#define HAVE_SYS_SOCKIO_H	1		/* <sys/sockio.h> */
#define HAVE_SYS_SYSCTL_H	1		/* <sys/sysctl.h> */
#define HAVE_SYS_TIME_H		1		/* <sys/time.h> */

/* Define if we can include <time.h> with <sys/time.h> */
#define TIME_WITH_SYS_TIME	1

/* Define the following if the function is provided */
#define HAVE_BZERO			1
#define HAVE_GETHOSTBYNAME	1
#define HAVE_VSNPRINTF		1

/* Define the following if the function prototype is in a header */
#define HAVE_GETHOSTNAME_PROTO	1	/* <unistd.h> */
#define HAVE_GETRUSAGE_PROTO	1	/* <sys/resource.h> */
#define HAVE_HSTRERROR_PROTO	1	/* <netdb.h> */
#define HAVE_INET_ATON_PROTO	1	/* <arpa/inet.h> */
#define HAVE_INET_PTON_PROTO	1	/* <arpa/inet.h> */
#define HAVE_SNPRINTF_PROTO		1	/* <stdio.h> */

/* Define the following if the strutured is defined */
#define HAVE_SOCKADDR_DL_STRUCT	1	/* <.h> */
#define HAVE_TIMESPEC_STRUCT	1	/* <.h> */

/* Define the following if the feature is defined */
#define HAVE_SOCKADDR_SA_LEN	1	/* sockadr{} has sa_len */
#define HAVE_MSGHDR_MSG_CONTROL	1	/* msghdr{} has msg_control member */

/* Define the following to the appropriate datatype, if necessary */
//#define uint8_t	unsigned char		/* <sys/type.h> */
//#define uint16_t	unsigned short		/* <sys/type.h> */
//#define uint32_t	unsigned int		/* <sys/type.h> */

/* socklen_t should be typedef'd as uint32_t, but configure defines
 * it to be an unsigned int, as it is needed early in the compile
 * process, sometimes before some implementations define uint32_t. */
//#define socklen_t	unsigned int	/* <sys/socket.h> */
//#define sa_family_t	SA_FAMILY_T		/* <sys/socket.h> */
//#define SA_FAMILY_T	uint8_t

/* Define the following, if system suports the feature */
#define IPV4		1	/* IPv4, uppercase V name */
#define IPv4		1	/* IPv4, lowercase V name */
#define UNIXDOMAIN	1	/* Unix domain sockets */
#define UNIXdomain	1	/* Unix domain sockets */
#define MCAST		1	/* multicasting support */
