#include <fcntl.h>

#include <netdb.h>
#include <netinet/in.h>
#include <netinet/tcp.h>

#include <openssl/ssl.h>
#include <openssl/err.h>
#include <openssl/crypto.h>
#include <openssl/x509.h>
#include <openssl/pem.h>
#include <openssl/bio.h>

#include <pthread.h>

#include <signal.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#include <unistd.h>

// define max clients waiting in the queue for connect
#ifndef __QUEUE_SIZE__
	#define __QUEUE_SIZE__ 10
#endif

// __SOCKET_ERROR__ must be -1, don't change this
#ifndef __SOCKET_ERROR__
	#define __SOCKET_ERROR__ -1
#endif

// the jabber's documentation recommends read the
// packages of socket with size of 4096 (2^12) KB
#ifndef __BUFFER_SIZE__
	#define __BUFFER_SIZE__ 4096
#endif
