function Connector()
{
}

Connector.prototype = {
	'go' : function()
	{
		// connection
		var __HTTP__ = null;
		var __THREADS__ = [];
		var index = 0;
		var rtlen = 0;
		var ie = false; // ie don't has stream
		function makeConnection()
		{
			if ( __HTTP__ == null )
				__HTTP__ = xhr();
		}
		function setPost(pThread)
		{
			__THREADS__[pThread].__METHOD__ = 'POST';
			return true;
		}
		// this set __THREADS__[?].__TYPE__ to 4 for request or 3 for stream
		function setStream(pThread)
		{
			__THREADS__[pThread].__TYPE__ = ( !ie ) ? 3 : 4;
			return true;
		}
		function trim(pData)
		{
			return pData.replace(/^ +| +$/g, '');
		}
		function verifyUserHandler(pThread, pHandler)
		{
			var type_of_handler = typeof pHandler;
			var i;
			switch ( type_of_handler )
			{
				case 'function' :
					return true;
				break;
				case 'object' :
					for ( i in pHandler )
						if ( i != 'stream' && i != 'request' )
							return false;
						else if ( i == 'stream' )
							setStream(pThread)
					return true;
				break;
				default :
					return false;
			}
		}
		// xhr = XMLHttpRequest
		function xhr()
		{
			try
			{
				return new XMLHttpRequest();
			}
			catch (e)
			{
				ie = true;
				try
				{
					return new ActiveXObject('Msxml2.XMLHTTP');
				}
				catch (e1)
				{
					try
					{
						return new ActiveXObject('Microsoft.XMLHTTP');
					}
					catch (e2)
					{
						return null;
					}
				}
			}
		}

		var __HANDLER__ = function()
		{
			try
			{
				if ( ie && __HTTP__.readyState != 4 )
					return false;

				var threadId = __HTTP__.getResponseHeader('ThreadId');
				if ( !threadId )
					return false;

				var type = __THREADS__[threadId].__TYPE__;
				if ( __HTTP__.readyState == 3 || __HTTP__.readyState == 4 )
				{
					if ( !ie && __HTTP__.readyState == 3 && __THREADS__[threadId].__HANDLER__.stream )
					{
						var data = trim(__HTTP__.responseText.substr(index));
						rtlen = __HTTP__.responseText.length;
						if ( index < rtlen && data.length )
						{
							__THREADS__[threadId].__HANDLER__.stream(data);
							index = rtlen;
						}
					}
					if ( __THREADS__[threadId].__HANDLER__.request && __HTTP__.readyState == 4 )
					{
						switch ( __HTTP__.status )
						{
							case 200:
								var data = ( __THREADS__[threadId].__MODE__ == 'XML' ) ?
									__HTTP__.responseXML :
									__HTTP__.responseText;

								if ( ie && __THREADS__[threadId].__HANDLER__.stream )
									__THREADS__[threadId].__HANDLER__.stream(data);

								if ( __THREADS__[threadId].__HANDLER__.request )
									__THREADS__[threadId].__HANDLER__.request(data);

								break; // [case : status 200]
							case 404:
								alert('Page Not Found!');
								break; // [case : status 404]
							default:
						}
					}
				}
				if ( __HTTP__.readyState == 4 )
				{
					delete __THREADS__[threadId];
				}
			}
			catch(e)
			{
				//alert("__HANDLER__\n" + threadId + "\n " + e + "\n ErroR: " + e.description);
				//delete __THREADS__[threadId];
			}
		};

		var argc = arguments.length;
		if ( argc < 2 || argc > 4 )
			return {'error':'#0 - invalid params'};

		if ( __THREADS__[arguments[0]] )
			return {'error':'#2 - request is running'};

		__THREADS__[arguments[0]] = {
			'__HANDLER__' : arguments[1],
			'__METHOD__'  : 'GET',  // __METHOD__ = [GET | POST]
			'__MODE__'    : 'TEXT', // __MODE__ = [XML | TEXT]
			'__TYPE__'    : 4       // __TYPE__ = [4 for request | 3 for stream]
		};

		makeConnection();

		if ( !verifyUserHandler(arguments[0], arguments[1]) )
		{
			delete __THREADS__[arguments[0]];
			return {'error':'#1 - invalid handler'};
		}

		if ( argc == 3 )
			setPost(arguments[0]);

		if ( __HTTP__ != null )
		{
			try
			{
				var __TARGET__ = path_im + 'controller.php?act=' + arguments[0];
				var __SEND__ = null;
				__HTTP__.open(__THREADS__[arguments[0]].__METHOD__, __TARGET__, true);
				if ( __THREADS__[arguments[0]].__METHOD__ == 'POST' )
				{
					__HTTP__.setRequestHeader('Content-Type','application/x-www-form-urlencoded');
					__HTTP__.setRequestHeader('Cache-Control',  'no-store, no-cache, must-revalidate');
					__HTTP__.setRequestHeader('Cache-Control', 'post-check=0, pre-check=0');
					__HTTP__.setRequestHeader('Pragma', 'no-cache');
					__SEND__ = arguments[2];
				}
				//__HTTP__.setRequestHeader('ThreadId', arguments[0]);
				//__HTTP__.setRequestHeader('Connection', 'close');
				//__HTTP__.setRequestHeader('Keep-Alive', '0');
				__HTTP__.onreadystatechange = __HANDLER__;
				__HTTP__.send(__SEND__);
			}
			catch(e)
			{
				alert("go\n" + e.description)
				return {'error':'#3 - ' + e.description};
			}
		}
	}
};
